#include <stdio.h>

int is_prime(unsigned long int n) {
    unsigned long int i, m;

    if (n < 2)
        return 0;
    
    i = n;
    m = n;
    while (i > 1) {
        i >>= 2;
        m >>= 1;
    }

    for (i = 2; i <= m; ++i) {
        if (n % i == 0) {
            return 0;
        }
    }

    return 1;
}

int main() {
    unsigned long int n;

    printf("Enter a number: ");
    scanf("%lu", &n);

    if (is_prime(n)) {
        printf("%lu is a prime number.\n", n);
    } else {
        printf("%lu is not a prime number.\n", n);
    }

    return 0;
}
